package ag;

import java.util.LinkedList;
import java.util.List;


import objects.GirafaObject;
import objects.WorldLogic;

public class EvoluidorNovo {

	private WorldLogic world;
	private Logic logic;

	public EvoluidorNovo(WorldLogic worldLogic, Logic logic) {
		this.logic = logic;
		this.world = worldLogic;
	}

	public List<GirafaObject> evolua(List<GirafaObject> popAtual, double porcentagem, double probMutacao) {
		System.out.println("Evoluindo");
		//TODO verificar se porcentagem esta entre 0 e 1
		
		List<GirafaObject> melhores = this.logic.getSelecionadorStrategy().selecioneMelhores(popAtual, porcentagem);
		
		List<String> melhoresCromossomos = getCromossomos(melhores);
		
		List<String> cromossomosFilhos = this.logic.getReprodutorStrategy().reproduza(melhoresCromossomos, probMutacao);
		
		return this.logic.getHeuristicaStrategy().apliqueHeuristica(popAtual, getGirafas(cromossomosFilhos));
	}
	
	
	private List<String> getCromossomos(List<GirafaObject> girafas) {
		List<String> cromossomos = new LinkedList<String>();
		
		for (GirafaObject girafa : girafas) {
			cromossomos.add(girafa.getCromossomo());
		}
		return cromossomos;
	}
	
	private List<GirafaObject> getGirafas(List<String> cromossomos) {
		List<GirafaObject> girafas = new LinkedList<GirafaObject>();
		for (String cromossomo : cromossomos) {
			girafas.add(new GirafaObject(this.world, logic.getSatisfacaoInicial(), logic.getPerdaSatisfacaoTempo(), logic.getSatisfacaoAoComer(), Integer.parseInt(cromossomo, 2)));
		}
		return girafas;
	}
}
