package ag;

public class Logic {

	private int numGirafas;

	private int numArvores;
	
	private int numIntervalos;
	
	private int numGeracoes;
	
	private HeuristicaStrategy heuristicaStrategy;
	
	private SelecionadorStrategy selecionadorStrategy;
	
	private ReprodutorStrategy reprodutorStrategy;

	private int mediaTamGirafas;

	private int varTamGirafas;

	private int satisfacaoInicial;
	
	private int satisfacaoAoComer;

	private int perdaSatisfacaoTempo;

	private int mediaTamArvores;

	private int varTamArvores;

	private double mutProb;

	private double percentagem;

	public Logic() {
		this(100, 26, 26, 1000, 10, 1, 2, 9, 3, 20, 40, new Heuristica1(), new Selecionador1(), new Reprodutor1(), 0.01, 0.20);
	}
	
	public Logic(int numGirafas, int mediaTamGirafas, int varTamGirafas,
			int satisfacaoInicial, int satisfacaoAoComer, int perdaSatisfacaoTempo, int numArvores,
			int mediaTamArvores, int varTamArvores, int numIntervalos, int numGeracoes,
			HeuristicaStrategy heuristicaStrategy, SelecionadorStrategy selecionadorStrategy,
			ReprodutorStrategy reprodutorStrategy, double mutProb, double percentagem) {
		
		this.numGirafas = numGirafas;
		this.mediaTamGirafas = mediaTamGirafas;
		this.varTamGirafas = varTamGirafas;
		this.satisfacaoInicial = satisfacaoInicial;
		this.perdaSatisfacaoTempo = perdaSatisfacaoTempo;
		this.satisfacaoAoComer = satisfacaoAoComer;
		this.numArvores = numArvores;
		this.mediaTamArvores = mediaTamArvores;
		this.varTamArvores = varTamArvores;
		this.numIntervalos = numIntervalos;
		this.numGeracoes = numGeracoes;
		this.heuristicaStrategy = heuristicaStrategy;
		this.selecionadorStrategy = selecionadorStrategy;
		this.reprodutorStrategy = reprodutorStrategy;
		this.mutProb = mutProb;
		this.percentagem = percentagem;
	}

	public Logic(Logic logic) {
		this(logic.getNumGirafas(), logic.getMediaTamGirafas(),
				logic.getVarTamGirafas(), logic.getSatisfacaoInicial(), logic.getSatisfacaoAoComer(),
				logic.getPerdaSatisfacaoTempo(), logic.getNumArvores(),
				logic.getMediaTamArvores(), logic.getVarTamArvores(),
				logic.getNumIntervalos(), logic.getNumGeracoes(), logic.getHeuristicaStrategy(),
				logic.getSelecionadorStrategy(), logic.getReprodutorStrategy(),
				logic.getMutProb(), logic.getPercentagem());
	}

	public void setHeuristicaStrategy(HeuristicaStrategy heuristicaStrategy) {
		this.heuristicaStrategy = heuristicaStrategy;
	}

	public void setMediaTamArvores(int mediaTamArvores) {
		this.mediaTamArvores = mediaTamArvores;
	}

	public void setMediaTamGirafas(int mediaTamGirafas) {
		this.mediaTamGirafas = mediaTamGirafas;
	}

	public void setMutProb(double mutProb) {
		this.mutProb = mutProb;
	}

	public void setPercentagem(double percentagem) {
		this.percentagem = percentagem;
	}
	
	public void setNumArvores(int numArvores) {
		this.numArvores = numArvores;
	}

	public void setNumGirafas(int numGirafas) {
		this.numGirafas = numGirafas;
	}

	public void setNumIntervalos(int numIntervalos) {
		this.numIntervalos = numIntervalos;
	}
	
	public void setNumGeracoes(int numGeracoes) {
		this.numGeracoes = numGeracoes;
	}

	public void setPerdaSatisfacaoTempo(int perdaSatisfacaoTempo) {
		this.perdaSatisfacaoTempo = perdaSatisfacaoTempo;
	}

	public void setReprodutorStrategy(ReprodutorStrategy reprodutorStrategy) {
		this.reprodutorStrategy = reprodutorStrategy;
	}

	public void setSatisfacaoInicial(int satisfacaoComer) {
		this.satisfacaoInicial = satisfacaoComer;
	}
	
	public void setSatisfacaoAoComer(int satisfacaoAoComer) {
		this.satisfacaoAoComer = satisfacaoAoComer;
	}

	public void setSelecionadorStrategy(SelecionadorStrategy selecionadorStrategy) {
		this.selecionadorStrategy = selecionadorStrategy;
	}

	public void setVarTamArvores(int varTamArvores) {
		this.varTamArvores = varTamArvores;
	}

	public void setVarTamGirafas(int varTamGirafas) {
		this.varTamGirafas = varTamGirafas;
	}

	public HeuristicaStrategy getHeuristicaStrategy() {
		return heuristicaStrategy;
	}

	public int getMediaTamArvores() {
		return mediaTamArvores;
	}

	public int getMediaTamGirafas() {
		return mediaTamGirafas;
	}

	public double getMutProb() {
		return mutProb;
	}

	public double getPercentagem() {
		return this.percentagem;
	}
	
	public int getNumArvores() {
		return numArvores;
	}

	public int getNumGirafas() {
		return numGirafas;
	}

	public int getNumIntervalos() {
		return numIntervalos;
	}
	
	public int getNumGeracoes() {
		return numGeracoes;
	}

	public int getPerdaSatisfacaoTempo() {
		return perdaSatisfacaoTempo;
	}

	public ReprodutorStrategy getReprodutorStrategy() {
		return reprodutorStrategy;
	}

	public int getSatisfacaoInicial() {
		return satisfacaoInicial;
	}
	
	public int getSatisfacaoAoComer() {
		return satisfacaoAoComer;
	}
	
	public SelecionadorStrategy getSelecionadorStrategy() {
		return selecionadorStrategy;
	}

	public int getVarTamArvores() {
		return varTamArvores;
	}

	public int getVarTamGirafas() {
		return varTamGirafas;
	}
}