package ag;

import java.util.LinkedList;
import java.util.List;

public class Reprodutor1 implements ReprodutorStrategy {

	public List<String> reproduza(List<String> girafasPais, double probMutacao) {
		//TODO verificar se eh um numero par de girafas
		List<String> filhos = new LinkedList<String>();
		
		for(int i = 0; i < girafasPais.size(); i += 2) {
			filhos.addAll(cruze(girafasPais.get(i), girafasPais.get(i+1), probMutacao));
		}
		return filhos;
	}
	
	public List<String> cruze(String cromossomo1, String cromossomo2, double probMutacao) {
		List<String> filhos = new LinkedList<String>();
		
		int posicao = (int) (Math.random() * (cromossomo1.length() - 1)) + 1;
		
		String filho1 = cromossomo1.substring(0, posicao) + cromossomo2.substring(posicao);
		String filho2 = cromossomo2.substring(0, posicao) + cromossomo1.substring(posicao);
		
		filho1 = this.apliqueMutacao(filho1, probMutacao);
		filho2 = this.apliqueMutacao(filho2, probMutacao);
		
		filhos.add(filho1);
		filhos.add(filho2);
		
		return filhos;
	}
	
	public String apliqueMutacao(String cromossomo, double probMutacao) {
		double random = Math.random();
		if (random < probMutacao) {
			int posicao = (int) (Math.random() * cromossomo.length());
			int valor = Character.getNumericValue(cromossomo.charAt(posicao));
			cromossomo = cromossomo.substring(0, posicao) + (valor ^ 1) + cromossomo.substring(posicao + 1);
			return cromossomo;
		}
		return cromossomo;
	}

}
