package base;
import java.awt.Graphics;


public abstract class AbstractObject implements WorldObject {

	protected int x;
	protected int y;
	protected int width;
	protected int height;

	protected AbstractObject() {
		this(0, 0, -1, -1);
	}
	
	protected AbstractObject(int x, int y) {
		this(x, y, -1, -1);
	}
	
	protected AbstractObject(int x, int y, int width, int height) {
		this.x = x;
		this.y = y;
		this.width = width;
		this.height = height;
	}
	
	public int getX() {
		return this.x;
	}
	
	public int getY() {
		return this.y;
	}

	public int getWidth() {
		return this.width;
	}

	public int getHeight() {
		return this.height;
	}

	public abstract void update();
	
	public abstract void paint(Graphics g);

}