package ui;
import java.awt.Graphics;

import javax.swing.JPanel;

import objects.WorldLogic;
import ag.Logic;

public class GirafasPanel extends JPanel implements Runnable {

	private final int DELAY = 100;
	
	private WorldLogic worldLogic;

	public GirafasPanel(int width, int height, Logic logic) {
		super.setSize(width, height);
		this.worldLogic = new WorldLogic(width, height, logic);
	}

	public void iniciar() {
		new Thread(this).start();
	}

	public void parar() {
		this.worldLogic.forcarParada();
	}
	
	public void paintComponent(Graphics g) {
		super.paintComponent(g);
		this.worldLogic.paint(g);
	}
	
	public void run() {
		while (!this.worldLogic.isOver()) {
			long before = System.currentTimeMillis();

			this.worldLogic.update();
			
			// flush graphics
			super.repaint();
			
			long after = System.currentTimeMillis();

			// delay
			try {
				Thread.sleep(Math.max(0, DELAY - (after - before)));
			} catch (InterruptedException e) {
				e.printStackTrace();
			}
		}
		
		// flush graphics
		super.repaint();
	}
}
