package objects;

import java.awt.Graphics;
import java.io.File;

import javax.swing.ImageIcon;

import base.AbstractObject;
import base.WorldObject;

public final class ArvoreObject extends AbstractObject {

	private WorldObject world;
	
	private ImageIcon copa;
	private ImageIcon tronco;
	private ImageIcon raiz;
	
	private int alturaDaArvore;
	private int tamanhoDoTronco;

	protected ArvoreObject(WorldObject world, int tamanhoDoTronco) {
		
		this.world = world;
		
		this.copa = new ImageIcon("imgs" + File.separator + "arvore" + File.separator + "copa.gif");
		this.tronco = new ImageIcon("imgs" + File.separator + "arvore" + File.separator + "tronco.gif");
		this.raiz = new ImageIcon("imgs" + File.separator + "arvore" + File.separator + "raiz.gif");
		
		this.tamanhoDoTronco = tamanhoDoTronco;
		this.alturaDaArvore = this.copa.getIconHeight() + this.tamanhoDoTronco * this.tronco.getIconHeight() + this.raiz.getIconHeight();
		
		super.width = this.raiz.getIconWidth();
		super.height = this.alturaDaArvore;
		super.x = geraPosicao();
		super.y = this.world.getHeight() - this.alturaDaArvore;
	}
	
	private int geraPosicao() {
		return (int) (Math.random() * (this.world.getWidth() - this.getWidth()));
	}

	@Override
	public void update() {
	}

	@Override
	public void paint(Graphics g) {
		this.copa.paintIcon(null, g, this.getX() - 70, this.getY());
		for (int i = 0; i < this.tamanhoDoTronco; i++) {
			this.tronco.paintIcon(null, g, this.getX() + 20,
					(this.getY() + this.copa.getIconHeight()) + i * this.tronco.getIconHeight());
		}
		this.raiz.paintIcon(null, g, this.getX(),
				(this.getY() + this.copa.getIconHeight()) + this.tamanhoDoTronco * this.tronco.getIconHeight());
	}

}
