package objects;

import java.awt.Graphics;
import java.io.File;

import javax.swing.ImageIcon;

import base.AbstractObject;
import base.WorldObject;

public class FundoObject extends AbstractObject implements WorldObject {

	private WorldObject world;
	
	private ImageIcon img;

	public FundoObject(WorldObject world) {
		this.world = world;
		this.img = new ImageIcon("imgs" + File.separator + "fundo.gif");
		
		super.x = 0;
		super.y = 0;
		super.width = this.world.getWidth();
		super.height = this.world.getHeight();
	}

	@Override
	public void update() {
	}

	@Override
	public void paint(Graphics g) {
		int nTiles = this.world.getWidth() / this.getWidth();

		for (int i = 0; i <= nTiles; i++) {
			this.img.paintIcon(null, g, this.getX() + i * this.img.getIconWidth(), this.getHeight() - this.img.getIconHeight());
		}
	}

}
