package escalonadores;

import java.util.Collection;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;

import simulador.Execucao;
import simulador.Maquina;
import simulador.Tarefa;

public class Workqueue implements EscalonadorIF {

	public String getNome() {
		return "Workqueue";
	}
	
	public List<Execucao> getExecucoes(Collection maquinas, Collection tarefas) {
		
		List<Execucao> execucoes = new LinkedList<Execucao>();
		Iterator<Maquina> maquinas_it = maquinas.iterator();
		Iterator<Tarefa> tarefas_it = tarefas.iterator();
		
		int cont = 1;
		while( tarefas_it.hasNext() && maquinas_it.hasNext()) {
			Tarefa tarefa = tarefas_it.next();
			Maquina maquina = maquinas_it.next();
			
			Execucao execucao = new Execucao(cont++, maquina, tarefa);
			execucoes.add(execucao);
			
			if(! maquinas_it.hasNext() )
				maquinas_it = maquinas.iterator();
		}
		
		
		return execucoes;
	}

}
