package simulador;

public class Execucao {
	
	private int id, uts_duracao, uts_restantes;
	private boolean terminada;
	
	private Maquina maquina;
	private Tarefa tarefa;
	
	public Execucao(int id, Maquina maquina, Tarefa tarefa) {
		this.id = id;
		this.maquina = maquina;
		this.tarefa = tarefa;
		this.terminada = false;
		calcula_uts();
	}

	public int getId() {
		return id;
	}
	
	public Maquina getMaquina() {
		return maquina;
	}

	public Tarefa getTarefa() {
		return tarefa;
	}
	
	public int getUts_duracao() {
		return uts_duracao;
	}
	
	public int getUts_restantes() {
		return uts_restantes;
	}
	
	public boolean equals(Object o) {
		Execucao execucao = (Execucao) o;
		return this.getId() == execucao.getId();
	}
	
	public boolean terminada() {
		return terminada;
	}
	
	public void termina() {
		terminada = true;
	}
	
	public void add_uts() {
		uts_restantes--;
	}
	
	public void uts() {
		uts_restantes++;
	}
	
	public void zera() {
		uts_restantes = uts_duracao;
		terminada = false;
	}
	
	private void calcula_uts() {
		uts_duracao = tarefa.getTamanho() / maquina.getVazao_link();
		uts_duracao += tarefa.getTamanho() / (tarefa.getVazao() * maquina.getVelocidade());
		uts_restantes = uts_duracao;
	}
	
	public String toString() {
		return "Execucao " + id + " (" + maquina.toString() + " | " + tarefa.toString() + ")";
	}
	
}
