package ui;

import java.io.BufferedReader;
import java.io.FileReader;

import simulador.Simulacao;
import util.LeitorArquivoCenario;
import escalonadores.EscalonadorIF;
import escalonadores.Genetico;
import escalonadores.Workqueue;

public class Simulador {

	public static void main(String[] args) throws Exception {
		
		if( args.length != 2 ) {
			imprime_uso();
			System.exit(1);
		}
		
		EscalonadorIF escalonador = null;
		if( args[0].equalsIgnoreCase("Workqueue") )
			escalonador = new Workqueue();
		else if( args[0].equalsIgnoreCase("Genetico") )
			escalonador = new Genetico();
		
		BufferedReader br = new BufferedReader( new FileReader(args[1]) );
		LeitorArquivoCenario lac = new LeitorArquivoCenario(br);
		
		Simulacao simulacao = new Simulacao(escalonador, lac.getTarefas(), lac.getMaquinas());
		
		int makespan = simulacao.simula();
		
		System.err.println("Makespan = " + makespan + " uts");

	}
	
	private static void imprime_uso() {
		
	}

}
