package util;

import java.io.BufferedWriter;
import java.io.FileWriter;
import java.io.IOException;

public class GeradorCenario {

	private String nome_do_arquivo;
	private int maq, vlink, vlink_var, vel, vel_var, tar, vaz, vaz_var, tam, tam_var;
	
	public GeradorCenario(String nome_do_arquivo) {
		this.nome_do_arquivo = nome_do_arquivo;
	}
	
	public void gera() {
		try {
			BufferedWriter bw = new BufferedWriter( new FileWriter(nome_do_arquivo) );
			bw.write( "Tarefas "  + tar);
			for(int i = 1; i <= tar; i++) {
				bw.newLine();
				bw.write( "   " + i + " " + calc(tam,tam_var) + " " + calc(vaz,vaz_var) );
			}
			bw.newLine(); bw.newLine();
			bw.write( "Maquinas " + maq);
			for(int i = 1; i <= maq; i++) {
				bw.newLine();
				bw.write( "   " + i + " " + calc(vlink,vlink_var) + " " + calc(vel,vel_var) );
			}
			bw.newLine();
			bw.flush();
			bw.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
	
	private int calc(int n, int nvaz) {
		int des = (int)(Math.random() * nvaz);
		int num = (int)(Math.random() * 2);
		if(num == 0) des = n + des;
		else des = n - des;
		return des;
	}
	
	public void setMaq(int maq) {
		this.maq = maq;
	}

	public void setTam(int tam) {
		this.tam = tam;
	}

	public void setTam_var(int tam_var) {
		this.tam_var = tam_var;
	}

	public void setTar(int tar) {
		this.tar = tar;
	}

	public void setVaz(int vaz) {
		this.vaz = vaz;
	}

	public void setVaz_var(int vaz_var) {
		this.vaz_var = vaz_var;
	}

	public void setVel(int vel) {
		this.vel = vel;
	}

	public void setVel_var(int vel_var) {
		this.vel_var = vel_var;
	}

	public void setVlink(int vlink) {
		this.vlink = vlink;
	}

	public void setVlink_var(int vlink_var) {
		this.vlink_var = vlink_var;
	}

	public static void main(String[] args) {
		
		System.out.println("Gerando...");
		
		GeradorCenario gc = new GeradorCenario(args[0]);
		gc.setMaq( Integer.parseInt(args[1]) );
		gc.setVlink( Integer.parseInt(args[2]) );
		gc.setVlink_var( Integer.parseInt(args[3]) );
		gc.setVel( Integer.parseInt(args[4]) );
		gc.setVel_var( Integer.parseInt(args[5]) );
		gc.setTar( Integer.parseInt(args[6]) );
		gc.setTam( Integer.parseInt(args[7]) );
		gc.setTam_var( Integer.parseInt(args[8]) );
		gc.setVaz( Integer.parseInt(args[9]) );
		gc.setVaz_var( Integer.parseInt(args[10]) );
		
		gc.gera();
		
		System.out.println("ok");

	}

}
