package util;

import java.io.BufferedReader;
import java.util.Collection;
import java.util.LinkedList;
import java.util.StringTokenizer;

import simulador.Maquina;
import simulador.Tarefa;

public class LeitorArquivoCenario {
	
	private Collection<Tarefa> tarefas;
	private Collection<Maquina> maquinas;
	
	public LeitorArquivoCenario(BufferedReader br) {
		faz_o_parser(br);
	}
	
	public Collection<Tarefa> getTarefas() {
		return tarefas;
	}
	
	public Collection<Maquina> getMaquinas() {
		return maquinas;
	}
	
	private void faz_o_parser(BufferedReader br) {
		tarefas = new LinkedList<Tarefa>();
		maquinas = new LinkedList<Maquina>();
		
		try {
			StringTokenizer st = new StringTokenizer( br.readLine() );
			st.nextToken(); //string Tarefas
			int n_tarefas = Integer.parseInt(st.nextToken());
			
			for(int i = 0; i < n_tarefas; i++) {
				st = new StringTokenizer( br.readLine() );
				int id = Integer.parseInt( st.nextToken() );
				int tamanho = Integer.parseInt( st.nextToken() );
				int vazao = Integer.parseInt( st.nextToken() );
				Tarefa tarefa = new Tarefa(id,tamanho,vazao);
				tarefas.add(tarefa);
			}
			
			br.readLine(); //linha em branco
			
			st = new StringTokenizer( br.readLine() );
			st.nextToken(); //string Maquinas
			int n_maquinas = Integer.parseInt(st.nextToken());
			
			for(int i = 0; i < n_maquinas; i++) {
				st = new StringTokenizer( br.readLine() );
				int id = Integer.parseInt( st.nextToken() );
				int vazao_link = Integer.parseInt( st.nextToken() );
				int velocidade = Integer.parseInt( st.nextToken() );
				Maquina maquina = new Maquina(id,vazao_link,velocidade);
				maquinas.add(maquina);
			}
			
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	
}
