package nom.paolo.ai.game.command;

import nom.paolo.ai.game.objects.Agent;


public class StayPutCommand extends AbstractAgentCommand {	
	private int delay;
	
	public StayPutCommand( String name, Agent target, int delay ) {
		super(name, target);
		
		this.delay = delay;
	}

		
	public StayPutCommand( Agent agent, int delay ) {
		this( "StayPut", agent, delay );
		
		this.agent = agent;
		this.delay = delay;
	}
	
	public void execute() {
		this.agent.moveLeft(0);
		this.agent.moveUp(0);
		this.delay--;
	}
	
	public boolean isFinished() {
		return this.delay <= 0;  
	}


	public void stop() {
		this.delay = 0;
	}

}
