package nom.paolo.ai.game.command;

import java.util.HashMap;
import java.util.Map;

import nom.paolo.ai.game.objects.Agent;

public abstract class AbstractAgentCommand implements AgentCommand {
	protected String commandName;
	protected Map<String,String> parameters;
	protected Agent agent;
		
	public AbstractAgentCommand( String name, Agent agent ) {
		this.commandName = name;
		this.parameters = new HashMap<String, String>();
		this.agent = agent;
	}
	
	public void setParameter( String parameterName, String value ) {
		this.parameters.put( parameterName, value );
	}
	
	public String getParameter( String parameterName ) {
		return this.parameters.get( parameterName );
	}
}
